#include "BasicBlockWidget.hxx"

BasicBlockWidget::BasicBlockWidget(const QString& name)
	: x(-5), y(-20)
	, dx(270), dy(45)
	, name(name) {
    _widget.setGridStyle(Qt::NoPen);
    _widget.setMinimumHeight(_widget.rowHeight(0) + 10);
    _widget.setMaximumHeight(20);
    _widget.resizeColumnToContents(0);
    _widget.resizeColumnToContents(1);
    _widget.resizeColumnToContents(2);
    _widget.updateGeometry();
    _widget.setMaximumWidth(260);
    _widget.setColumnCount(3);
    _widget.verticalHeader()->hide();
    _widget.horizontalHeader()->hide();
    dx = _widget.rowHeight(0) + 20;
    if (dx < 270) dx = 270;
}

void BasicBlockWidget::addItem(uint8_t* bytes, size_t num_bytes,
                               const QString& line) {
    size_t current_row = _widget.rowCount();
    int column_width;

    QString bytestring;

    for (size_t i(0); i < num_bytes; ++i) {
        const char * hexdigits = "0123456789ABCDEF";
        bytestring += hexdigits[(bytes[i] >> 4) & 0xF];
        bytestring += hexdigits[bytes[i] & 0xF];
        bytestring += ' ';
    }

    _widget.setRowCount(current_row + 1);

    _widget.setItem(current_row, 0, new QTableWidgetItem(bytestring));
    _widget.setItem(current_row, 1, new QTableWidgetItem(line));
    _widget.setItem(current_row, 2, new QTableWidgetItem(""));
    _widget.updateGeometry();

    _widget.resizeColumnToContents(0);
    _widget.resizeColumnToContents(1);
    _widget.resizeColumnToContents(2);

    _widget.resizeRowToContents(current_row);

    column_width =
        _widget.columnWidth(0) +
        _widget.columnWidth(1) +
        _widget.columnWidth(2) +
        2;

    _widget.setMinimumWidth(column_width);
    _widget.setMinimumHeight(_widget.rowHeight(0) * (_widget.rowCount()) + 2);
    _widget.setMaximumHeight(_widget.rowHeight(0) * (_widget.rowCount()) + 2);


    dy = _widget.rowHeight(0) * (_widget.rowCount()) + 25;
    dx = column_width + 10;
    if (dx < 270) dx = 270;
}
