#include "gui/qt.hxx"
#include "disassembler/BasicBlock.hxx"

class BasicBlockWidget : public QGraphicsItem
{
public:
    BasicBlockWidget(const QString& name);

	void addItem(uint8_t* bytes, size_t num_bytes, const QString& line);

    QRectF boundingRect() const  {
        qreal penWidth = 1;
        return QRectF(x - penWidth / 2, y - penWidth / 2,
                      dx + penWidth, dy + penWidth);
    }

	QPointF getEntry() const {
		return QPointF(x + dx/2, y);
	}

    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
               QWidget *widget) {
        painter->fillRect(x, y, dx, dy, QColor(0xcc, 0xcc, 0xff, 0xff));
        painter->setPen(QColor(0x00, 0x00, 0xff, 0xff));
        painter->drawRect(x, y, dx, dy);
        painter->drawText(0, -5, name);
        _widget.render(painter);
    }
private:
    int x, y, dx, dy;
    QTableWidget _widget;
	QString name;
	BasicBlock * block;
};
